<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Attributes\Appends;
use Illuminate\Database\Eloquent\Attributes\Guarded;
use Illuminate\Database\Eloquent\Casts\Attribute;
use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Relations\BelongsTo;
use Illuminate\Database\Eloquent\SoftDeletes;

#[Appends(['formatted_material_result', 'formatted_material_usage'])]
#[Guarded(['id'])]
class CuttingMaterial extends Model
{
    use HasFactory, SoftDeletes;

    protected function casts(): array
    {
        return [
            'material_usage' => 'integer',
            'material_result' => 'integer',
        ];
    }

    protected function formattedMaterialResult(): Attribute
    {
        return Attribute::make(
            get: fn () => number_format($this->material_result, 0, ',', '.'),
        );
    }

    protected function formattedMaterialUsage(): Attribute
    {
        return Attribute::make(
            get: fn () => number_format($this->material_usage, 0, ',', '.'),
        );
    }

    public function combination(): BelongsTo
    {
        return $this->belongsTo(CuttingMaterialCombination::class, 'combination_id');
    }

    public function cutting(): BelongsTo
    {
        return $this->belongsTo(Cutting::class);
    }

    public function rawMaterialPrice(): BelongsTo
    {
        return $this->belongsTo(RawMaterialPrice::class);
    }

    public function user(): BelongsTo
    {
        return $this->belongsTo(User::class);
    }
}
